/**************************************************************************\
*
* MCPainter -- ͼƬתschematicļMCEditMinecraft
*
*                           Copyright (c) 2013, ٶ - ԭŵûJ8.
*
\**************************************************************************/

#include <windows.h>
#include <GdiPlus.h>
using namespace Gdiplus;
#pragma comment(lib, "Gdiplus.lib")
#pragma comment(lib, "msimg32.lib")
#include "Functions.h"
#include "resource.h"


HINSTANCE hInst;							// ʵ
CHAR szTitle[] = "MCPainter";				// ڱ
CHAR szWindowClass[] = "MCPainter";		// 

#define DISTANCE 16 //Ӵڼ
#define ID_BTN1 1
#define ID_BTN2 2
#define ID_STATIC1 3
#define ID_STATIC2 4
HWND hMainWindow, hButton1, hButton2, hStatic1, hStatic2;

ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;

    MyRegisterClass(hInstance);

    if (!InitInstance (hInstance, nCmdShow))
    {
        return FALSE;
    }

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}



//עᴰ
ATOM MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASSEX wcex;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style			= CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc	= (WNDPROC)WndProc;
    wcex.cbClsExtra		= 0;
    wcex.cbWndExtra		= 0;
    wcex.hInstance		= hInstance;
    wcex.hIcon			= LoadIcon (hInstance, MAKEINTRESOURCE(IDI_ICON1));
    wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszMenuName	= NULL;
    wcex.lpszClassName	= szWindowClass;
    wcex.hIconSm		= LoadIcon (hInstance, MAKEINTRESOURCE(IDI_ICON1));

    return RegisterClassEx(&wcex);
}

//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

    hInst = hInstance; // Store instance handle in our global variable

    hMainWindow = CreateWindow(szWindowClass, szTitle, WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_CAPTION | WS_SYSMENU | WS_GROUP
		, GetSystemMetrics(SM_CXSCREEN) / 2 - 654 / 2, GetSystemMetrics(SM_CYSCREEN) / 2 - 413 / 2
		, DISTANCE * 3 + 300 * 2 + 3 * 2, DISTANCE * 3 + 300 + 30 + 32 + 3, NULL, NULL, hInstance, NULL);

    if (!hMainWindow)
    {
        return FALSE;
    }

    ShowWindow(hMainWindow, nCmdShow);
    UpdateWindow(hMainWindow);

    return TRUE;
}

void OnCreate(HWND hWnd);
void OnDestroy();
void Static1_OnDraw(HDC hdc);
void Static2_OnDraw(HDC hdc);
void OnDestroy();
void BTN1_OnClick();
void BTN2_OnClick();

//ڹ(Ϣ)
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPDRAWITEMSTRUCT pdis;

    switch (message)
    {
    case WM_CREATE:
        OnCreate(hWnd);
        break;
    case WM_COMMAND:
        if (HIWORD(wParam) == BN_CLICKED)
            switch (LOWORD(wParam))
            {
            case ID_BTN1:
                BTN1_OnClick();
                break;
            case ID_BTN2:
                BTN2_OnClick();
                break;
            }
        break;
	case WM_DRAWITEM:
        pdis = (LPDRAWITEMSTRUCT)lParam;
		switch(pdis->CtlID)
		{
			case ID_STATIC1:
				Static1_OnDraw(pdis->hDC);
				break;
			case ID_STATIC2:
				Static2_OnDraw(pdis->hDC);
				break;
		}
        break;
    case WM_CLOSE:
        DestroyWindow(hWnd);
        break;
    case WM_DESTROY:
		OnDestroy();
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

/////////////////////////////////////Ƭʼ///////////////////////////////////////////

static ULONG_PTR m_gdiplusToken;//GDI+ʼ
static DWORD ImgWidth, ImgHeight;//ͼƬ
static DWORD FixedWidth, FixedHeight;//źͼƬ
static MDC mdc1, mdc2;//ڴDCͼƬͶȡARGB

COLOR Colors[1000];//ɫ
byte ID[1000], Data[1000];//MCID,
int nColor = 0;//ɫ
static int *BlockIndex;//תضӦɫе   //**˳Ҵµ**

//ڴ
void OnCreate(HWND hWnd)
{
	//ɫ
	if(!Input())
	{
		MessageBox(hMainWindow, "ɫʧܣ", szTitle, MB_OK | MB_ICONERROR);
		DestroyWindow(hWnd);
		return;
	}
	//GDI+ʼ
	Gdiplus::GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);
	//ͨöԻʼ
	Initialize(hWnd, hInst);

	//Ӵ
    hButton1 = CreateWindow("Button", "ѡͼƬ", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON
                           , DISTANCE + 300 - 100, DISTANCE * 2 + 300, 100, 30
						   , hWnd, (HMENU)ID_BTN1, hInst, NULL);
    hButton2 = CreateWindow("Button", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON
                           , DISTANCE * 2 + 300, DISTANCE * 2 + 300, 100, 30
						   , hWnd, (HMENU)ID_BTN2, hInst, NULL);
	hStatic1 = CreateWindow("Static", NULL, WS_CHILD | WS_VISIBLE | SS_OWNERDRAW
                           , DISTANCE, DISTANCE, 300, 300
						   , hWnd, (HMENU)ID_STATIC1, hInst, NULL);
	hStatic2 = CreateWindow("Static", NULL, WS_CHILD | WS_VISIBLE | SS_OWNERDRAW
                           , DISTANCE * 2 + 300, DISTANCE, 300, 300
						   , hWnd, (HMENU)ID_STATIC2, hInst, NULL);
}

//
void OnDestroy()
{
	delete [] BlockIndex;
	Gdiplus::GdiplusShutdown(m_gdiplusToken); 
}

//Static1ͼ
void Static1_OnDraw(HDC hdc)
{
	RECT rc;
	rc.left = 0;
	rc.top = 0;
	rc.right = 300;
	rc.bottom = 300;

	FillRect(hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
	if(mdc1.hdc)
	{
		BLENDFUNCTION bf;
		bf.BlendOp = AC_SRC_OVER;
		bf.BlendFlags = 0;
		bf.SourceConstantAlpha = 255;
		bf.AlphaFormat = AC_SRC_NO_PREMULT_ALPHA;
		AlphaBlend(hdc, 0, 0, FixedWidth, FixedHeight, mdc1.hdc, 0, 0, ImgWidth, ImgHeight, bf);
	}
	FrameRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
}

//Static2ͼ
void Static2_OnDraw(HDC hdc)
{
	RECT rc;
	rc.left = 0;
	rc.top = 0;
	rc.right = 300;
	rc.bottom = 300;

	FillRect(hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
	if(mdc2.hdc)
	{
		BLENDFUNCTION bf;
		bf.BlendOp = AC_SRC_OVER;
		bf.BlendFlags = 0;
		bf.SourceConstantAlpha = 255;
		bf.AlphaFormat = AC_SRC_NO_PREMULT_ALPHA;
		AlphaBlend(hdc, 0, 0, FixedWidth, FixedHeight, mdc2.hdc, 0, 0, ImgWidth, ImgHeight, bf);
	}
	FrameRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
}

//ѡͼƬť
void BTN1_OnClick()
{
	//ͨöԻѡͼƬ
	const char Filter[] = "ͼƬļ(*.jpg;*.png;*.bmp)\0*.jpg;*.png;*.bmp\0" \
					"ļ(*.*)\0*.*\0";
	char FileName[MAX_PATH];

	if(!OpenFileDlg(FileName, Filter, "jpg")) return;

	//ȡͼƬ
	WCHAR wFileName[MAX_PATH];
	MultiByteToWideChar(CP_ACP, 0, FileName, -1, wFileName, sizeof(wFileName));
	Image Img(wFileName);
	ImgWidth = Img.GetWidth();
	ImgHeight = Img.GetHeight();

	//
	if(ImgWidth > 300 || ImgHeight > 300)
	{
		if(ImgWidth > ImgHeight)
		{
			FixedHeight = (DWORD)((double)ImgHeight / ImgWidth * 300);
			FixedWidth = 300;
		}
		else
		{
			FixedWidth = (DWORD)((double)ImgWidth / ImgHeight * 300);
			FixedHeight = 300;
		}
	}
	else
	{
		FixedWidth = ImgWidth;
		FixedHeight = ImgHeight;
	}
	if((ImgWidth > 300 || ImgHeight > 300) && MessageBox(hMainWindow, "Ƿŵ300x300ڣ"
		, szTitle, MB_YESNO | MB_ICONQUESTION) == IDYES)
	{
		ImgWidth = FixedWidth;
		ImgHeight = FixedHeight;
	}

	//mdc1
	mdc1.Create(ImgWidth, ImgHeight);
	Graphics Gra(mdc1.hdc);
	Gra.DrawImage(&Img, 0, 0, ImgWidth,ImgHeight);

	//תӽɫ
	mdc2.Create(ImgWidth, ImgHeight);
	int i, Len = ImgWidth * ImgHeight, Index;//ǰ,ͼƬ,ɫ
	delete [] BlockIndex;
	BlockIndex = new int[Len];
	for(i = 0 ; i < Len ; i++)
	{
		if((mdc1.Data + i) -> byColor.A > 229)//Բ͸<90%
		{
			Index = GetNearestColorIndex(*(mdc1.Data + i));
			BlockIndex[i] = Index;//**˳Ҵµ**
			(mdc2.Data + i) -> crColor = Colors[Index].crColor;
		}
		else
		{
			BlockIndex[i] = -1;//ԣ
		}
	}

	//ػStatic
	InvalidateRect(hStatic1, NULL, TRUE);
	InvalidateRect(hStatic2, NULL, TRUE);
}

#include <cstdio>

//תint4ֽ
DWORD ReverseInt(DWORD i)
{
	DWORD res;
	res = (i & 0xFF000000) >> 24;
	res |= (i & 0x00FF0000) >> 8;
	res |= (i & 0x0000FF00) << 8;
	res |= (i & 0x000000FF) << 24;
	return res;
}

//תshort2ֽ
DWORD ReverseShort(DWORD s)
{
	DWORD res;
	res = (s & 0xFF00) >> 8;
	res |= (s & 0x00FF) << 8;
	return res;
}

//ɰť
void BTN2_OnClick()
{
    const char Filter[] = "schematicļ(*.schematic)\0*.schematic\0";
	char FileName[MAX_PATH];

	if(!SaveFileDlg(FileName, Filter, "schematic")) return;

	FILE *f;
	f = fopen(FileName, "wb");
	if(f == NULL)
	{
		MessageBox(hMainWindow, "ļʧܣ", szTitle, MB_OK | MB_ICONERROR);
		return;
	}

	//дļ
	DWORD Tmp;
	//ͷ
	Tmp = 0x0A;//TAG_Compound
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0900;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Schematic", 9, 1, f);//ǩ
	
	//߳ = 1
	Tmp = 0x02;//TAG_Short
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0600;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Height", 6, 1, f);//ǩ
	Tmp = 0x0100;//ֵ
	fwrite(&Tmp, 2, 1, f);

	//ݳ
	Tmp = 0x02;//TAG_Short
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0600;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Length", 6, 1, f);//ǩ
	Tmp = ReverseShort(ImgHeight);//ֵ
	fwrite(&Tmp, 2, 1, f);

	//᳤
	Tmp = 0x02;//TAG_Short
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0500;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Width", 5, 1, f);//ǩ
	Tmp = ReverseShort(ImgWidth);//ֵ
	fwrite(&Tmp, 2, 1, f);

	//ʵ
	Tmp = 0x09;//TAG_List
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0800;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Entities", 8, 1, f);//ǩ
	Tmp = 0x0A;
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0;
	fwrite(&Tmp, 4, 1, f);

	Tmp = 0x09;//TAG_List
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0C00;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("TileEntities", 12, 1, f);//ǩ
	Tmp = 0x0A;
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0;
	fwrite(&Tmp, 4, 1, f);


	//汾 = Alpha
	Tmp = 0x08;//TAG_String
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0900;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Materials", 9, 1, f);//ǩ
	Tmp = 0x0500;//ֵ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Alpha", 5, 1, f);//ֵ

	//ID
	Tmp = 0x07;//TAG_Byte_Array
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0600;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Blocks", 6, 1, f);//ǩ
	int Len = ImgWidth * ImgHeight;
	Tmp = ReverseInt(Len);//ֵ
	fwrite(&Tmp, 4, 1, f);
	//**Ҵϵ**дID
	DWORD x, y;
	int *pIndex, iIndex;//ǰָ,ֵ
	pIndex = BlockIndex + Len - ImgWidth;
	for(y = 0 ; y < ImgHeight ; y++)
	{
		for(x = 0 ; x < ImgWidth ; x++)
		{
			iIndex = *pIndex;
			if(iIndex == -1)//-1ɿ
				Tmp = 0;
			else
				Tmp = ID[iIndex];
			fwrite(&Tmp, 1, 1, f);
			pIndex++;
		}
		pIndex -= ImgWidth * 2;
	}

	//
	Tmp = 0x07;//TAG_Byte_Array
	fwrite(&Tmp, 1, 1, f);
	Tmp = 0x0400;//ǩ
	fwrite(&Tmp, 2, 1, f);
	fwrite("Data", 4, 1, f);//ǩ
	Tmp = ReverseInt(Len);//ֵ
	fwrite(&Tmp, 4, 1, f);
	//**Ҵϵ**д
	pIndex = BlockIndex + Len - ImgWidth;
	for(y = 0 ; y < ImgHeight ; y++)
	{
		for(x = 0 ; x < ImgWidth ; x++)
		{
			iIndex = *pIndex;
			if(iIndex == -1)//-1ɿ
				Tmp = 0;
			else
				Tmp = Data[iIndex];
			fwrite(&Tmp, 1, 1, f);
			pIndex++;
		}
		pIndex -= ImgWidth * 2;
	}

	//β
	Tmp = 0x00;//TAG_End
	fwrite(&Tmp, 1, 1, f);

	fclose(f);

	//gzipѹҲԲѹ
}
