void Initialize(HWND hwnd, HINSTANCE hInstance);
BOOL OpenFileDlg(LPSTR pstrFile, LPCSTR szFilter, LPCSTR szDefExt);
BOOL SaveFileDlg(LPSTR pstrFile, LPCSTR szFilter, LPCSTR szDefExt);

union COLOR
{
	COLORREF crColor;
	struct
	{
		byte B, G, R, A;
	} byColor;
};

class MDC
{
	public:
	HDC hdc;
	HBITMAP hBitmap;
	COLOR *Data;

	MDC();
	~MDC();
	void Create(int nWidth, int nHeight);
	void Destroy();

	private:
	BITMAPINFO info;
	HBITMAP OldBitmap;
};

bool Input();
double GetDistance(BYTE R1, BYTE G1, BYTE B1, BYTE R2, BYTE G2, BYTE B2);
int GetNearestColorIndex(COLOR ParamColor);
